unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    PaintBox1: TPaintBox;
    procedure FormPaint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure paintedges(box : TPaintbox);  

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses hdunit;

var selcolor : dword; //the selected color

procedure paintedges(box : TPaintbox);
var x1,y1,x2,y2 : word;
    fm : TcustomForm;
begin
 fm := getparentform(box);
 with box do
  begin
   x1 := Left-1;
   x2 := Left + Width;
   y1 := Top - 1;
   y2 := Top+ Height;
  end;
 with fm.canvas do
  begin
   pen.color := $000000;
   pen.width := 1;
   moveto(x1,y1);
   lineto(x1,y2);
   lineto(x2,y2);
   lineto(x2,y1);
   lineto(x1,y1);
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintedges(paintbox1);
end;

procedure TForm1.Button1Click(Sender: TObject);
//select button
var col : dword;
begin
 col := selcolor;
 if colordialog(col) then
  begin
   selcolor := col;
   paintbox1.invalidate;
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 with paintbox1 do with canvas do
  begin
   brush.color := selcolor;
   brush.style := bsSolid;
   fillrect(rect(0,0,width,height));
  end;
end;

end.
